package com.mytest.rest.model;

import java.io.Serializable;
import java.net.URI;

import javax.ws.rs.core.UriBuilder;

import org.codehaus.jackson.map.annotate.JsonSerialize;
import org.codehaus.jackson.map.annotate.JsonSerialize.Inclusion;


@JsonSerialize(include = Inclusion.NON_EMPTY)
public class MyObjectContainer implements Serializable{
	public static final String URIPATTERN ="/mycontainer/{id}";
	
	
	private MyObject my;

	public MyObject getMy() {
		return my;
	}

	public void setMy(MyObject my) {
		this.my = my;
	}
	
	protected URI buildUri() {
		return UriBuilder.fromPath(URIPATTERN).build(getId());
	}
	
	private Long id;
	private URI uri;

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the uri
	 */
	public final URI getUri() {
		if (null == uri) {
			uri = buildUri();
		}
		return uri;
	}


	/**
	 * @param uri the uri to set
	 */
	public void setUri(URI uri) {
		this.uri = uri;
	}

	@Override
	public String toString() {
		return "QueryResultItem [" + getUri() + "]";
	}

	

}
